package de.hhu.stups.codegenerator.blackbox;

import de.hhu.stups.codegenerator.CodeGenerator;
import de.hhu.stups.codegenerator.blackbox.traces.TraceGenerator;
import org.junit.Ignore;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

import static org.junit.Assert.assertEquals;

/**
 * Created by fabian on 31.05.18.
 */

@Ignore
public class TestBlackBox {

	public static void writeInputToSystem(InputStream inputStream) throws IOException {
		writeInputToOutput(inputStream, System.out);
	}

	private static String streamToString(InputStream inputStream) throws IOException {
		ByteArrayOutputStream result = new ByteArrayOutputStream();
		byte[] buffer = new byte[1024];
		int length;
		while ((length = inputStream.read(buffer)) != -1) {
			result.write(buffer, 0, length);
		}
		return result.toString();
	}

	public static void writeInputToOutput(InputStream inputStream, OutputStream outputStream) throws IOException {
		int size;
		byte[] buffer = new byte[1024];
		while ((size = inputStream.read(buffer)) != -1)
			outputStream.write(buffer, 0, size);
	}

	public void testBlackBox(String machine, String name, String modelPath, String learningTechnique, int episodes) throws Exception {
		Path mchPath = Paths.get(CodeGenerator.class.getClassLoader()
				.getResource("de/hhu/stups/codegenerator/blackbox/" + machine + ".mch").toURI());

		CodeGenerator codeGenerator = new CodeGenerator();
		codeGenerator.generateBlackBoxTraceGenerator(mchPath, name, modelPath, learningTechnique, episodes,
				String.valueOf(Integer.MIN_VALUE),
				String.valueOf(Integer.MAX_VALUE),
				"10");
	}


	private void cleanUp(String path) {
		File file = new File(path);
		if (file.exists()) {
			file.delete();
		}
	}

}
