import {BInteger} from './btypes/BInteger.js';
import {BBoolean} from './btypes/BBoolean.js';
import CAN_BUS_tlc from './CAN_BUS_tlc.js';
import {BUtils} from "./btypes/BUtils.js";
import {SelectError} from "./btypes/BUtils.js";



export default class CAN_BUS_tlc_exec {

    _CAN_BUS_tlc: CAN_BUS_tlc = new CAN_BUS_tlc();



    private counter: BInteger;

    constructor() {
        this.counter = new BInteger(0);
    }


     simulate(): void {
        this._CAN_BUS_tlc.Update(new BInteger(0));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T2Calculate();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(1));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(1));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(1));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(1));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1).negative());
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1).negative());
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Calculate(new BInteger(3));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(3));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(0));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T2Reset();
        this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3Poll();
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(5));
        this._CAN_BUS_tlc.T2Evaluate();
        this._CAN_BUS_tlc.T3Evaluate();
        this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T2Complete();
        this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
        this._CAN_BUS_tlc.T2Wait(new BInteger(3));
        this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
        this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
        this._CAN_BUS_tlc.T3ReEnableWait();
        this._CAN_BUS_tlc.Update(new BInteger(3));
        this._CAN_BUS_tlc.T1Evaluate();
        this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
        this._CAN_BUS_tlc.T3Initiate();
        this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
        this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
        this._CAN_BUS_tlc.T1Wait(new BInteger(2));
        this._CAN_BUS_tlc.T3Wait();
        this._CAN_BUS_tlc.Update(new BInteger(4));
        while((this.counter.less(new BInteger(300000))).booleanValue()) {
            this._CAN_BUS_tlc.T3Evaluate();
            this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
            this._CAN_BUS_tlc.T3Poll();
            this._CAN_BUS_tlc.T3Wait();
            this._CAN_BUS_tlc.Update(new BInteger(4));
            this._CAN_BUS_tlc.T3Evaluate();
            this._CAN_BUS_tlc.T2Evaluate();
            this._CAN_BUS_tlc.T3Read(new BInteger(4),new BInteger(0));
            this._CAN_BUS_tlc.T2ReadBus(new BInteger(4),new BInteger(0));
            this._CAN_BUS_tlc.T3Poll();
            this._CAN_BUS_tlc.T2Reset();
            this._CAN_BUS_tlc.T3Wait();
            this._CAN_BUS_tlc.T1Evaluate();
            this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
            this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
            this._CAN_BUS_tlc.T2WriteBus(new BInteger(5),new BInteger(0));
            this._CAN_BUS_tlc.T2Wait(new BInteger(3));
            this._CAN_BUS_tlc.T1Wait(new BInteger(2));
            this._CAN_BUS_tlc.Update(new BInteger(5));
            this._CAN_BUS_tlc.T3Evaluate();
            this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
            this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
            this._CAN_BUS_tlc.T3ReEnableWait();
            this._CAN_BUS_tlc.Update(new BInteger(5));
            this._CAN_BUS_tlc.T1Evaluate();
            this._CAN_BUS_tlc.T1Calculate(new BInteger(2));
            this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(2));
            this._CAN_BUS_tlc.T3Initiate();
            this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
            this._CAN_BUS_tlc.T1Wait(new BInteger(2));
            this._CAN_BUS_tlc.T3Wait();
            this._CAN_BUS_tlc.Update(new BInteger(5));
            this._CAN_BUS_tlc.T2Evaluate();
            this._CAN_BUS_tlc.T3Evaluate();
            this._CAN_BUS_tlc.T2ReadBus(new BInteger(5),new BInteger(0));
            this._CAN_BUS_tlc.T2Complete();
            this._CAN_BUS_tlc.T2ReleaseBus(new BInteger(5));
            this._CAN_BUS_tlc.T2Wait(new BInteger(3));
            this._CAN_BUS_tlc.T3Read(new BInteger(5),new BInteger(0));
            this._CAN_BUS_tlc.T3ReleaseBus(new BInteger(4));
            this._CAN_BUS_tlc.T3ReEnableWait();
            this._CAN_BUS_tlc.Update(new BInteger(3));
            this._CAN_BUS_tlc.T1Evaluate();
            this._CAN_BUS_tlc.T1Calculate(new BInteger(1));
            this._CAN_BUS_tlc.T3Initiate();
            this._CAN_BUS_tlc.T1SendResult(new BInteger(3),new BInteger(1));
            this._CAN_BUS_tlc.T3writebus(new BInteger(4),new BInteger(0));
            this._CAN_BUS_tlc.T1Wait(new BInteger(2));
            this._CAN_BUS_tlc.T3Wait();
            this._CAN_BUS_tlc.Update(new BInteger(4));
            this.counter = this.counter.plus(new BInteger(1));
        }
    }

    _get_counter(): BInteger {
        return this.counter;
    }


}

let exec: CAN_BUS_tlc_exec = new CAN_BUS_tlc_exec();
exec.simulate();